#include <stdio.h>

/* simple hex editor          */
/* last updated: june 6, 2015 */

/* This was added for modern Linux */

#include <stdlib.h>
#include <string.h>

/* needs the following functions:
 * scanf feof system ioctl fopen fseek fgetc fprintf
 * isprint strcpy gets
 */

#include <termio.h>
#include <fcntl.h>
#include <ctype.h>

long counter;
long line_size;
int end_file;

FILE *fp;
char fn[14];

main(argc, argv)
int argc;
char *argv[];
{
	int rr;

	if (argc == 1)
	{
		printf ("enter name of file: ");
		gets(fn);
	}
	else if (argc > 1)
	{
		strcpy(fn,argv[1]);
	}

	rr = load();
	if (rr == -1)
		exit_out(0);

	end_file=0;
	line_size = 16L;
	body();
	printf ("\nExiting\n");
	exit_out(1);
}

body()
{
	char k;

	counter = 0L;

	system("stty -echo");

	show_file(fp);
	while (k !='q')
	{
		k = getcr();
		if (k =='-' && counter > 0)
		{
			end_file = 0;
			counter--;
			fseek (fp, line_size*counter,0);
			show_file(fp);
		}
		else if ((k =='+' || k==' ') && end_file == 0)
		{
			counter++;
			fseek(fp, line_size*counter, 0);
			show_file(fp);
		}
		else if ( k =='e')
		{
			edit_line(fp);

			/* after each edit it's necessary to seek again */

			fseek (fp, line_size*counter, 0);
			show_file(fp);
		}
		else if (k =='l')
		{
			set_line(fp);
			show_file(fp);
		}
		else if (k=='s')
		{
			system("stty echo");
			system("sh");
			system("stty -echo");
			printf ("\nBack to hexedit\n");
		}
		else if (k=='r')
		{
			printf ("\n     00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f\n");
		}
	}
}

show_file(fp)
FILE *fp;
{
	int x, y, rc, lim, first_time;
	unsigned char temp[50];

	first_time = 0;
	for (x=0; x<=(int)(line_size-1); x++)
	{
		temp[x] = (unsigned char)fgetc(fp);
		rc = feof(fp);
		if (rc)
		{
			lim = x-1;
			end_file = 1;
			/* space out when no more data */
			for (y=0; y<=line_size-x-1; y++)
				printf ("   ");
			break;
		}
		if (first_time == 0)
		{
			printf ("%0004x ", counter);
			first_time = 1;
		}
		printf ("%02x ", temp[x]);
		lim = (int)(line_size-1);
	}
	printf (" ");
	for (x=0; x<=lim; x++)
	{
		if (lim == 0)
			break;

		if (isprint(temp[x]))
			printf ("%c", temp[x]);
		else
			printf (".");
	}
	if (lim !=0)
		printf ("\n");

	return(0);
}

edit_line(fp)
FILE *fp;
{
	int val;
	int rc;
	long pos;

	system("stty echo");
	printf ("\n     00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f");
	printf ("\nEdit) value offset: ");
	scanf ("%x %lx", &val, &pos);

	val = (unsigned char) val;
	rc = fseek (fp, line_size*counter+pos,0);
	rc = fprintf (fp, "%c", val); 
	system ("stty -echo");
}

set_line(fp)
FILE *fp;
{
	int rc, temp;

	temp = counter;
	system ("stty echo");
	printf ("\nLine: ");
	scanf ("%lx", &counter);
	fseek (fp, line_size*counter, 0);

	fgetc(fp);
	rc = feof(fp);

	if (rc)
	{
		printf ("\nInvalid line\n");
		fseek (fp, line_size*temp, 0);
		counter = temp;
	}
	else
	{
		end_file = 0;
		fseek (fp, line_size*counter, 0);
	}
	system ("stty -echo");
}

getcr()
{
	int rc, fd;
	struct termio arg, arg1;

	if ((fd = open("/dev/tty", O_RDWR)) == -1)
	{
		printf ("Can't Open For RW\n");
		return(-1);
	}

	ioctl (fd, TCGETA, &arg);
	arg.c_lflag -= (ICANON);
	arg.c_cc[4] = 0000001;
	ioctl (fd, TCSETAW, &arg);

	rc = getchar();

	ioctl (fd, TCGETA, &arg);
	arg.c_lflag += (ICANON);
	arg.c_cc[4] = 0000004;
	ioctl (fd, TCSETAW, &arg);

	close (fd);

	return(rc);
}

load()
{
	int rc=0;

	fp = fopen(fn, "r+");
	if (fp == NULL)
	{
		printf ("\nCan't open file\n");
		rc = -1;
	}
	return(rc);
}

exit_out(close_flag)
int close_flag;
{
	system("stty echo");
	if (close_flag == 1)
		fclose(fp);

	exit(0);
}
